data bib;
input block @@;
 do eu=1 to 3;
  input trt @@;
   p1=0.10; p2=0.20; p3=0.20; p4=0.10; p5=0.25; p6=0.35;
   p=(trt=1)*p1+(trt=2)*p2+(trt=3)*p3+(trt=4)*p4+(trt=5)*p5+(trt=6)*p6;
   n=50;
   mu=n*p;
   output;
 end;
datalines;
 1  1 2 3
 2  1 2 4
 3  1 3 5
 4  1 4 6
 5  1 5 6
 6  2 3 6
 7  2 4 5
 8  2 5 6
 9  3 4 5
10  3 4 6
;
proc glimmix data=bib initglm;
 class block trt;
 model mu/n=trt;
 random intercept trt/subject=block;
 parms (0.09)(0.07) / hold=1,2;
 lsmestimate trt 'trt 1 v 2' 1 -1 0  0 0 0,
                 'trt 1 v 3' 1 0 -1  0 0 0,
                 'trt 4 v 5' 0 0 0  1 -1 0,
                 'trt 4 v 6' 0 0 0  1 0 -1,
                 'trt 2 v 5' 0 1 0  0 -1 0,
                 'trt 3 v 6' 0 0 1  0 0 -1 / cl exp;
 contrast 'product' trt 1 -1 0 1 -1 0,
                    trt 1 0 -1 1 0 -1;
 contrast 'dose' trt 1 1 1 -1 -1 -1;
 contrast 'product x dose' trt 1 -1 0 -1 1 0,
                           trt 1 0 -1 -1 0 1;
ods output contrasts=ftests lsmestimates=bib_diff;
run;
data power_bib; 
 set ftests;
  alpha=0.05;
  phi=numdf*fvalue;
  fcrit=finv(1-alpha,numdf,dendf,0);
  power_bib=1-probf(fcrit,numdf,dendf,phi);
proc print data=power_bib;
run;
data bib_diff;
 set bib_diff;
 stderr_bib=stderr;
 LCL_bib=ExpLower;
 UCL_bib=Expupper;
 drop estimate stderr lower upper;
run;

data splt;
input block @@;
 do eu=1 to 3;
  input trt @@;
   p1=0.10; p2=0.20; p3=0.20; p4=0.10; p5=0.25; p6=0.35;
   p=(trt=1)*p1+(trt=2)*p2+(trt=3)*p3+(trt=4)*p4+(trt=5)*p5+(trt=6)*p6;
   n=50;
   mu=n*p;
   output;
 end;
datalines;
 1  1 2 3
 2  4 5 6
 3  1 2 3
 4  4 5 6
 5  1 2 3
 6  4 5 6
 7  1 2 3
 8  4 5 6
 9  1 2 3
10  4 5 6
;
proc glimmix data=splt initglm;
 class block trt;
 model mu/n=trt;
 random intercept trt/subject=block;
 parms (0.09)(0.07) / hold=1,2;
 lsmestimate trt 'trt 1 v 2' 1 -1 0  0 0 0,
                 'trt 1 v 3' 1 0 -1  0 0 0,
                 'trt 4 v 5' 0 0 0  1 -1 0,
                 'trt 4 v 6' 0 0 0  1 0 -1,
                 'trt 2 v 5' 0 1 0  0 -1 0,
                 'trt 3 v 6' 0 0 1  0 0 -1 / cl exp;
 contrast 'product' trt 1 -1 0 1 -1 0,
                    trt 1 0 -1 1 0 -1;
 contrast 'dose' trt 1 1 1 -1 -1 -1;
 contrast 'product x dose' trt 1 -1 0 -1 1 0,
                           trt 1 0 -1 -1 0 1;
ods output contrasts=ftests lsmestimates=splt_diff;
run;
data splt_diff;
 set splt_diff;
 stderr_splt=stderr;
 LCL_splt=ExpLower;
 UCL_splt=Expupper;
 drop estimate stderr lower upper;
run;

data power_splt; 
 set ftests;
  alpha=0.05;
  phi=numdf*fvalue;
  fcrit=finv(1-alpha,numdf,dendf,0);
  power_splt=1-probf(fcrit,numdf,dendf,phi);
proc print data=power_splt;
run;
data power_all;
 merge power_bib power_splt;
proc print data=power_all;
 var label power_bib power_splt;
run;
data all_diff;
 merge bib_diff splt_diff;
proc print data=all_diff;
 var label stderr_bib stderr_splt LCL_bib UCL_bib LCL_splt UCL_splt;
run;
