/* create exemplary data set */
/* balanced incomplete block */
data bib;
 input block @@;
  do eu=1 to 3;
   input trt @@;
   mu=0;
   output;
  end;
datalines;
 1  1 2 3
 2  1 2 4
 3  1 3 5
 4  1 4 6
 5  1 5 6
 6  2 3 6
 7  2 4 5
 8  2 5 6
 9  3 4 5
10  3 4 6
;
proc glimmix data=bib;
 class block trt;
 model mu=trt;
 random intercept / subject=block;
 parms (0.5)(1)/hold=1,2;
 lsmeans trt/diff cl;
 ods output diffs=lsm_bib;
run;

/* control vs others */
data cvo;
 input block @@;
  do eu=1 to 3;
   input trt @@;
   mu=0;
   output;
  end;
datalines;
 1  1 2 3
 2  1 2 4
 3  1 2 5
 4  1 2 6
 5  1 3 4
 6  1 3 5
 7  1 3 6
 8  1 4 5
 9  1 4 6
10  1 5 6
;
proc glimmix data=cvo;
 class block trt;
 model mu=trt;
 random intercept / subject=block;
 parms (0.5)(1)/hold=1,2;
 lsmeans trt/diff cl;
 ods output diffs=lsm_cvo;
run;

/* split-plot - group-nested */
data splt;
 input block @@;
  do eu=1 to 3;
   input trt @@;
   mu=0;
   output;
  end;
datalines;
 1  1 2 3
 2  4 5 6
 3  1 2 3
 4  4 5 6
 5  1 2 3
 6  4 5 6
 7  1 2 3
 8  4 5 6
 9  1 2 3
10  4 5 6
;
proc glimmix data=splt;
 class block trt;
 model mu=trt;
 random intercept / subject=block;
 parms (0.5)(1)/hold=1,2;
 lsmeans trt/diff cl;
 ods output diffs=lsm_splt;
run;
data diff_bib;
 set lsm_bib;
  bib_sed=stderr;
  bib_LCL=lower;
  bib_UCL=upper;
  drop effect estimate stderr df alpha tvalue probt lower upper;
 proc sort; by trt _trt;
 proc print data=diff_bib;
 run;
data diff_cvo;
 set lsm_cvo;
  cvo_sed=stderr;
  cvo_LCL=lower;
  cvo_UCL=upper;
  drop effect estimate stderr df alpha tvalue probt lower upper;
 proc sort; by trt _trt;
 proc print data=diff_cvo;
 run;
data diff_splt;
 set lsm_splt;
  splt_sed=stderr;
  splt_LCL=lower;
  splt_UCL=upper;
  drop effect estimate stderr df alpha tvalue probt lower upper;
 proc sort; by trt _trt;
 proc print data=diff_splt;
 run;
 data all;
  merge diff_bib diff_cvo diff_splt;
  by trt _trt;
proc print data=all;
run;

proc print data=all;
/* not used in paper - table too wide */
  var trt _trt bib_sed cvo_sed splt_sed bib_LCL bib_UCL cvo_LCL cvo_UCL splt_LCL splt_UCL;
 run;

proc print data=all;
  var trt _trt bib_sed cvo_sed splt_sed;
 run;

proc print data=all;
  var trt _trt bib_LCL bib_UCL cvo_LCL cvo_UCL splt_LCL splt_UCL;
 run;
